/*
 *      $Id: casPVListChanIL.h,v 1.1.1.1 1996/06/20 00:28:16 jhill Exp $
 *
 *      Author  Jeffrey O. Hill
 *              johill@lanl.gov
 *              505 665 1831
 *
 *      Experimental Physics and Industrial Control System (EPICS)
 *
 *      Copyright 1991, the Regents of the University of California,
 *      and the University of Chicago Board of Governors.
 *
 *      This software was produced under  U.S. Government contracts:
 *      (W-7405-ENG-36) at the Los Alamos National Laboratory,
 *      and (W-31-109-ENG-38) at Argonne National Laboratory.
 *
 *      Initial development by:
 *              The Controls and Automation Group (AT-8)
 *              Ground Test Accelerator
 *              Accelerator Technology Division
 *              Los Alamos National Laboratory
 *
 *      Co-developed with
 *              The Controls and Computing Group
 *              Accelerator Systems Division
 *              Advanced Photon Source
 *              Argonne National Laboratory
 *
 *
 * History
 * $Log: casPVListChanIL.h,v $
 * Revision 1.1.1.1  1996/06/20 00:28:16  jhill
 * ca server installation
 *
 *
 */


#ifndef casPVListChanIL_h
#define casPVListChanIL_h

//
// casPVListChan::casPVListChan()
//
inline casPVListChan::casPVListChan 
	(const casCtx &ctx, casChannel &chanAdapterIn) :
	casChannelI(ctx, chanAdapterIn)
{
	this->pv.installChannel(*this);
}

//
// casPVListChan::~casPVListChan()
//
inline casPVListChan::~casPVListChan()
{
	this->pv.removeChannel(*this);
	//
	// delete signal to PV occurs in 
	// casChannelI::~casChannelI
	//
}

#endif // casPVListChanIL_h

